//+------------------------------------------------------------------+
//|                                              T.O.P.S.(DSVT1).mq4 |
//|                                Trend Oriented Positioning System |
//|                                                  dsvt1@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "dsvt1"
#property link      "dsvt1@yahoo.com"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_color3 Red
#property indicator_color4 Green
#property indicator_color5 Red
#property indicator_color6 Green
#property indicator_color7 Blue
#property indicator_color8 Yellow

//---- input parameters
extern bool      BuyAlarm=False;
extern bool      SellAlarm=False;
extern bool      BuyAlert=False;
extern bool      SellAlert=False;
extern bool      EmailBuyAlert=False;
extern bool      EmailSellAlert=False;
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
//+------------------------------------------------------------------+
//|Update for V4 - removed 50%R,added MA filter and median ref line  |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,ExtMapBuffer8);
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int    counted_bars=IndicatorCounted();
  //---- check for possible errors
   if(counted_bars<0) return(-1);
  //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
  //---- main loop
     for(int i=0; i<limit; i++)
       {
        //----shift set to 0 because SetIndexShift called abowe
         ExtMapBuffer1[i]=iEnvelopes(NULL, 0, 24,MODE_SMA,0,PRICE_CLOSE,0.23,MODE_UPPER,i);
         ExtMapBuffer2[i]=iEnvelopes(NULL, 0, 24,MODE_SMA,0,PRICE_CLOSE,0.23,MODE_LOWER,i);
         ExtMapBuffer3[i]=iEnvelopes(NULL, 0, 24,MODE_SMA,0,PRICE_CLOSE,0.38,MODE_UPPER,i);
         ExtMapBuffer4[i]=iEnvelopes(NULL, 0, 24,MODE_SMA,0,PRICE_CLOSE,0.38,MODE_LOWER,i);
         ExtMapBuffer5[i]=iEnvelopes(NULL, 0, 24,MODE_SMA,0,PRICE_CLOSE,0.62,MODE_UPPER,i);
         ExtMapBuffer6[i]=iEnvelopes(NULL, 0, 24,MODE_SMA,0,PRICE_CLOSE,0.62,MODE_LOWER,i);
         ExtMapBuffer7[i]=iMA(NULL,0,150,0,MODE_EMA,PRICE_MEDIAN,i);
         ExtMapBuffer8[i]=iMA(NULL,0,2,0,MODE_SMA,PRICE_MEDIAN,i);
       }
       
       //+--------------------------------------------------------------------------+
       //-                       BuyAlarm    PlaySound("alert2.wav");               -
       //+--------------------------------------------------------------------------+
      if(BuyAlarm)
      {
         if(Close[i]==ExtMapBuffer2[i] || Close[i]==ExtMapBuffer4[i])
         {
            PlaySound("alert2.wav");
         }
         if(Close[i]==ExtMapBuffer4[i] || Close[i]==ExtMapBuffer2[i])
         {
            PlaySound("alert2.wav");
         }         
        
      }
         
  //---- done
  
       //+--------------------------------------------------------------------------+
       //-                    SellAlarm      PlaySound("alert2.wav");               -
       //+--------------------------------------------------------------------------+
      if(SellAlarm)
      {
         if(Close[i]==ExtMapBuffer1[i] || Close[i]==ExtMapBuffer3[i])
         {
            PlaySound("alert2.wav");
            
         }
         if(Close[i]==ExtMapBuffer3[i] || Close[i]==ExtMapBuffer1[i])
         {
            PlaySound("alert2.wav");
            
         }         
        
      }
         
  //---- done  
       //+--------------------------------------------------------------------------+
       //-                       BuyAlert    Alert Box                              -
       //+--------------------------------------------------------------------------+
      if(BuyAlert)
      {
         if(Close[i]==ExtMapBuffer2[i] || Close[i]==ExtMapBuffer4[i])
         {
            Alert("Buy Signal triggered for "+Symbol()+" on the "+Period()+" minute chart.");
         }
         if(Close[i]==ExtMapBuffer4[i] || Close[i]==ExtMapBuffer2[i])
         {
            Alert("Buy Signal triggered for "+Symbol()+" on the "+Period()+" minute chart.");
         }         
        
      }
         
  //---- done
  
       //+--------------------------------------------------------------------------+
       //-                    SellAlert      Alert Box                              -
       //+--------------------------------------------------------------------------+
      if(SellAlert)
      {
         if(Close[i]==ExtMapBuffer1[i] || Close[i]==ExtMapBuffer3[i])
         {
            Alert("Sell Signal triggered for "+Symbol()+" on the "+Period()+" minute chart.");
            
         }
         if(Close[i]==ExtMapBuffer3[i] || Close[i]==ExtMapBuffer1[i])
         {
            Alert("Sell Signal triggered for "+Symbol()+" on the "+Period()+" minute chart.");
            
         }         
        
      }
         
  //---- done  
         //+--------------------------------------------------------------------------+
         //-                       EmailBuyAlert  (UNFINISHED)                        -
         //+--------------------------------------------------------------------------+
      if(EmailBuyAlert)
      {
         if(Close[i]==ExtMapBuffer2[i] || Close[i]==ExtMapBuffer4[i])
         {
            Alert("Buy Signal triggered for "+Symbol()+" on the "+Period()+" minute chart.");
         }
         if(Close[i]==ExtMapBuffer4[i] || Close[i]==ExtMapBuffer2[i])
         {
            Alert("Buy Signal triggered for "+Symbol()+" on the "+Period()+" minute chart.");
         }         
        
      }
         
  //---- done
  
       //+--------------------------------------------------------------------------+
       //-                    EmailSellAlert (UNFINISHED)                           -
       //+--------------------------------------------------------------------------+
      if(EmailSellAlert)
      {
         if(Close[i]==ExtMapBuffer1[i] || Close[i]==ExtMapBuffer3[i])
         {
            Alert("Sell Signal triggered for "+Symbol()+" on the "+Period()+" minute chart.");
            
         }
         if(Close[i]==ExtMapBuffer3[i] || Close[i]==ExtMapBuffer1[i])
         {
            Alert("Sell Signal triggered for "+Symbol()+" on the "+Period()+" minute chart.");
            
         }         
        
      }
         
  //---- done  
   return(0);
  }
//+------------------------------------------------------------------+

